#pragma once

#include "FrameOperation.h"
#include "OverlayMode.h"

#include "atltypes.h"

class FieldPatch : public PatchOperation
{
private:
	~FieldPatch() {}
private: // attributes
	LONG m_targetOrder;
	LONG m_sourceFrame;
	LONG m_sourceOrder;
	CPoint m_sourceOrigin;
	HOverlay m_mode;
public:
	LONG targetOrder() const;

	LONG sourceFrame() const;
	LONG sourceOrder() const;

	CPoint sourceOrigin() const;
	CRect sourceRect() const;
	int sourceX() const;
	int sourceY() const;

	HOverlay mode() const;
	void setMode(HOverlay mode);

	bool usesFrame(LONG frame) const;

public:
	explicit FieldPatch(CVclipDoc& owner, 
		LONG sourceFrame = 0, LONG sourceOrder = 0, int sourceX = 0, int sourceY = 0, int sourceWidth = 0, int sourceHeight = 0,
		LONG targetFrame = 0, LONG targetOrder = 0, int targetX = 0, int targetY = 0, HOverlay mode = the<Overlays>()["Blend"]);
	
	const char* typeCode() const;
	void writeTo(std::ostream& stream) const;
	void readFrom(std::istream& stream);

	void accept(IOperationVisitor& visitor);
};
