#pragma once

#include "FrameOperation.h"
#include "OverlayMode.h"

#include "atltypes.h"

class FramePatch : public PatchOperation
{
private:
	~FramePatch() {}
private: // attributes
	LONG m_sourceFrame;
	CPoint m_sourceOrigin;
	HOverlay m_mode;
public:
	LONG sourceFrame() const;

	CPoint sourceOrigin() const;
	CRect sourceRect() const;
	int sourceX() const;
	int sourceY() const;

	HOverlay mode() const;
	void setMode(HOverlay mode);

	bool usesFrame(LONG frame) const;

public:
	explicit FramePatch(CVclipDoc& owner, 
		LONG sourceFrame = 0, int sourceX = 0, int sourceY = 0, int sourceWidth = 0, int sourceHeight = 0,
		LONG targetFrame = 0, int targetX = 0, int targetY = 0, HOverlay mode = Overlays::instance()["Blend"]);
	
	const char* typeCode() const;
	void writeTo(std::ostream& stream) const;
	void readFrom(std::istream& stream);

	void accept(IOperationVisitor& visitor);
};

