#include "stdafx.h"

#include "TemporaryFile.h"
#include "exception.h"

TemporaryFilename::TemporaryFilename(const std::string& extension)
{
	char path[MAX_PATH];
	ASSERT_NE(GetTempPath(sizeof(path) / sizeof(*path), path), 0, "GetTempPath");
	std::ostringstream oss;
	do
	{
		oss.str("");
		oss << path << "\\" << std::hex;
		for (size_t i = 0; i < 8; ++i)
		{
			oss << "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"[rand() % 36];
		}
		oss << extension;

	}
	while (INVALID_HANDLE_VALUE == (m_handle = CreateFile(
		oss.str().c_str(), GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE, 0, CREATE_NEW, 0, 0)));
	CloseHandle(m_handle);
	m_filename = oss.str().c_str();
}

TemporaryFilename::~TemporaryFilename()
{
	DeleteFile(m_filename.c_str());
}

const char* TemporaryFilename::c_str() const
{
	return m_filename.c_str();
}
